c
c ---------------------------------------------------------------
c
      subroutine a4step1(maxmx,mbc,mx,meqn,maux,xlower,dx,
     &           time,dt,q,qold,aux,auxold,dq,work,mwork,
     &           mthlim,mwaves,mthbc)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension qold(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension auxold(1-mbc:maxmx+mbc,maux)
      dimension dq(1-mbc:maxmx+mbc,meqn)
      dimension work(mwork)
      dimension mthlim(mwaves),mthbc(2)
c
c     # dispersive wave problems
c     # elliptic equation step
c
      locaa  = 1
      locbb  = locaa+(maxmx+2*mbc)
      loccc  = locbb+(maxmx+2*mbc)
      locdd  = loccc+(maxmx+2*mbc)
      locwk1 = locdd+(maxmx+2*mbc)
      locwk2 = locwk1+(maxmx+2*mbc)
      iused  = locwk2+(maxmx+2*mbc)-1
c
      if (iused .gt. mwork) then
          write(6,*) '*** not enough work space in a4step1'
          write(6,*) '*** iused = ', iused, '   mwork =',mwork
          stop
      endif
c
      call bc1(maxmx,meqn,mbc,mx,xlower,dx,q,maux,aux,time,
     &     dt,mthbc)
c
c     # elliptic solver for dispersive wave problems
      call dsw_ellp(maxmx,mbc,mx,meqn,maux,
     &     dx,q,aux,work(locaa),work(locbb),
     &     work(loccc),work(locdd),work(locwk1),
     &     work(locwk2),ma1,ma2)
c
c     # boundary condition for auxiliary states
      call bc1_aux(maxmx,ma1,ma2,mbc,mx,
     &     xlower,dx,maux,aux,t,dt,mthbc)
      return
c
      end
