c
c ------------------------------------------------------------
c
      subroutine dsw_ellp(maxmx,mbc,mx,meqn,maux,
     &           dx,q,aux,aa,bb,cc,dd,beta,eta,ma1,ma2)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension aa(1-mbc:maxmx+mbc)
      dimension bb(1-mbc:maxmx+mbc)
      dimension cc(1-mbc:maxmx+mbc)
      dimension dd(1-mbc:maxmx+mbc)
      dimension beta(1-mbc:maxmx+mbc)
      dimension eta(1-mbc:maxmx+mbc)
c
c     # BBM model
c     # post-processing step 
c     # solve elliptic-like equation 
c     # q-eps*q_xx = RHS    
c
c     # fourth order compact method
c
      dx2 = dx*dx
c
c     # set discretized linear system of equation
      do i=1,mx
c        # sub-diagonal
         aa(i) = -aux(i,5)/dx2
         aa(i) = aa(i)-1.d0/12.d0
c
c        # sup-diagonal
         cc(i) = -aux(i,5)/dx2
         cc(i) = cc(i)-1.d0/12.d0
c
c        # diagonal
         bb(i) = 1.d0-(aa(i)+cc(i))
c
c        # right-hand side
         dd(i) = q(i,1)
         dd(i) = dd(i)-
     &           (q(i-1,1)-2.0d0*q(i,1)+q(i+1,1))/12.d0
c
         if (i .eq. 1) then
c            # left bc
c
             bb(1) = bb(1)+aa(1)
         elseif (i .eq. mx) then
c            # right bc
c
             bb(mx) = bb(mx)+cc(mx)
         endif
         enddo
c
c     # solve tridiagonal linear systems
      call thomas(aa,bb,cc,dd,maxmx,mbc,1,mx)
c
c     # store velocity      
      do i=1,mx
         aux(i,6) = dd(i)
         enddo
c
      ma1 = 6
      ma2 = 6
      return
c
      end
