c
c-----------------------------------------------------------------
c
      subroutine rp_solver(ql_state,qr_state,aux1,aux2,
     &           delta,s_local,wave_local,qrp_local,
     &           dtdx,meqn)
      implicit double precision (a-h,o-z)
      dimension ql_state(20),qr_state(20)
      dimension aux1(20),aux2(20)
      dimension s_local(20)
      dimension wave_local(20,20)
      dimension qrp_local(20)
      dimension delta(20)
      dimension flux1(20)
      dimension flux2(20)
      dimension fluxm(20)
c
c     # BBM model
c     # approximate Riemann solver
c     # local Lax-Friedrichs approach
c
      call ctomfd(ql_state,aux1,rho1,auxK1,w1,c1)
      call ctomfd(qr_state,aux2,rho2,auxK2,w2,c2)
c
c     # flux: left-hand side
      flux1(1) = w1                
c
c     # flux: right-hand side
      flux2(1) = w2                
c
c     # Rusanov flux
      aj0 = dmax1(dabs(c1),dabs(c2))
      fluxm(1) = 0.5d0*(flux1(1)+flux2(1)-
     &      aj0*(qr_state(1)-ql_state(1)))
c
c     # write flux-difference in wave-propagation form
      c0 = 0.5d0*(c1+c2)
      if (c0 .gt. 0.d0) then
          s_local(2) = c0
          s_local(1) = -s_local(2)
      else
          s_local(1) = c0
          s_local(2) = -s_local(1)
      endif
c
      if (dabs(s_local(1)) .ne. 0.d0) then
          wave_local(1,1) = (fluxm(1)-flux1(1))/s_local(1)
          wave_local(1,2) = (flux2(1)-fluxm(1))/s_local(2)
      else
          wave_local(1,1) = 0.d0
          wave_local(1,2) = 0.d0
      endif
      return
c
      end
