c
c-----------------------------------------------------------------
c
      subroutine rp_solver(ql_state,qr_state,aux1,aux2,
     &           delta,s_local,wave_local,qrp_local,
     &           dtdx,meqn)
      implicit double precision (a-h,o-z)
      dimension ql_state(20),qr_state(20)
      dimension aux1(20),aux2(20)
      dimension s_local(20)
      dimension wave_local(20,20)
      dimension qrp_local(20)
      dimension delta(20)
      dimension flux1(20)
      dimension flux2(20)
      dimension qhll(20)
c
c     # BBMH model
c     # approximate Riemann solver
c     # HLL approach
c
      call ctomfd(ql_state,aux1,u1,f11,f21,f31,c1)
      call ctomfd(qr_state,aux2,u2,f12,f22,f32,c2)
c
c     # fluxes: left-hand side 
      flux1(1) = f11                
      flux1(2) = f21                
      flux1(3) = f31                
c
c     # fluxes: right-hand side 
      flux2(1) = f12                
      flux2(2) = f22                
      flux2(3) = f32                
c
c     # wave speed estimate: left-hand side
      s_local(1) = dmin1(0.5d0*(u1-dsqrt(u1**2+4.0d0*c1)),
     &                   0.5d0*(u2-dsqrt(u2**2+4.0d0*c2)))
c
c     # wave speed estimate: right-hand side
      s_local(2) = dmax1(0.5d0*(u1+dsqrt(u1**2+4.0d0*c1)),
     &                   0.5d0*(u2+dsqrt(u2**2+4.0d0*c2)))
c
c     # HLL middle-state
      do m=1,meqn
         qhll(m) = ((s_local(2)*qr_state(m)-
     &      s_local(1)*ql_state(m))-
     &      (flux2(m)-flux1(m)))/(s_local(2)-s_local(1))
         enddo
c
c     # jumps across each wave
      do m=1,meqn
         wave_local(m,1) = qhll(m)-ql_state(m)
         wave_local(m,2) = qr_state(m)-qhll(m)
         enddo
      return
c
      end
