c
c ------------------------------------------------------------------
c
      subroutine hdsw_relax(maxmx,mbc,mx,meqn,maux,
     &           q,qold,aux,auxold,dt)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension qold(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension auxold(1-mbc:maxmx+mbc,maux)
c
c     # BBMH relaxation step
c     # exact ODE solution
c
      do i=1,mx
         u0 = q(i,1)
         v0 = aux(i,6)*q(i,2)
         w0 = q(i,3)
c
         em  = aux(i,6)/aux(i,5)
         a1  = v0   
         a2  = aux(i,6)/dsqrt(em)*w0    
         v1  = a1*dcos(dsqrt(em)*dt)+a2*dsin(dsqrt(em)*dt)
         vt1 = -a1*dsqrt(em)*dsin(dsqrt(em)*dt)+
     &          a2*dsqrt(em)*dcos(dsqrt(em)*dt)
c
         q(i,2) = v1/aux(i,6)
         q(i,3) = vt1/aux(i,6)
         enddo   
      return
c
      end
