c
c-----------------------------------------------------------------
c
      subroutine rp1(maxmx,meqn,mwaves,mbc,maux,mx,ql,qr,
     &           auxl,auxr,wave,s,amdq,apdq,qrp,dtdx)
      implicit double precision (a-h,o-z)
      dimension ql(1-mbc:maxmx+mbc,meqn)
      dimension qr(1-mbc:maxmx+mbc,meqn)
      dimension s(1-mbc:maxmx+mbc,mwaves)
      dimension wave(1-mbc:maxmx+mbc,meqn,mwaves)
      dimension amdq(1-mbc:maxmx+mbc,meqn)
      dimension apdq(1-mbc:maxmx+mbc,meqn)
      dimension auxl(1-mbc:maxmx+mbc,maux)
      dimension auxr(1-mbc:maxmx+mbc,maux)
      dimension qrp(1-mbc:maxmx+mbc,meqn)
      dimension dtdx(1-mbc:maxmx+mbc)
      dimension ql_state(20),qr_state(20)
      dimension aux1(20),aux2(20)
      dimension s_local(20)
      dimension wave_local(20,20)
      dimension qrp_local(20)
      dimension delta(20)
c
c     # solve Riemann problems 
c
      do i=2-mbc,mx+mbc
         do m=1,meqn
            ql_state(m) = qr(i-1,m)
            qr_state(m) = ql(i,m)
            enddo
c
         do ma=1,maux
            aux1(ma) = auxr(i-1,ma)
            aux2(ma) = auxl(i,ma)
            enddo
c
         do m=1,meqn
            delta(m) = qr_state(m)-ql_state(m)
            enddo
c
         call rp_solver(ql_state,qr_state,aux1,aux2,
     &        delta,s_local,wave_local,qrp_local,
     &        dtdx(i),meqn)
c
         do mw=1,mwaves
            s(i,mw) = s_local(mw)
            do m=1,meqn
               wave(i,m,mw) = wave_local(m,mw)
               enddo
            enddo
c
c        # amdq = SUM s*wave over left-going waves
c        # apdq = SUM s*wave over right-going waves
c
         do m=1,meqn
            amdq(i,m) = 0.d0
            apdq(i,m) = 0.d0
            do mw=1,mwaves
               if (s(i,mw) .lt. 0.d0) then
                   amdq(i,m) = amdq(i,m)+s(i,mw)*wave(i,m,mw)
               else
                   apdq(i,m) = apdq(i,m)+s(i,mw)*wave(i,m,mw)
               endif
               enddo   
            enddo
         enddo
      return
c
      end
