c
c---------------------------------------------------------------
c
      subroutine setaux_info(maxmx,mbc,mx,xlower,dx,mcapa,
     &           maux,aux)
      implicit double precision (a-h,o-z)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension quad(0:1,1)
c
      if (maux .lt. mcapa) then
         write(6,*) 'setaux1_info : maux must be >= 1 when using '
         write(6,*) 'mapped grids with routine setaux1_info.f'
         stop
      endif
c
      if (mcapa .ne. 1) then
         write(6,'(A,A,I2,A)') 'setaux1_info : mcapa should ',
     &         'be set to 1 when using setaux1_info.'
         stop
      endif
c
      do i=1-mbc,mx+mbc
         xe = xlower+dble(i-1)*dx
c
         do icell=0,1
            xc = xe+dble(icell)*dx
            call mapc2p(xc,xp)
c
            quad(icell,1) = xp
            enddo

         call compute_info1(quad,area,xc)
c
c        # Capacity
         if (area .le. 0.d0) then
             write(6,*) 'setaux1_info : capacity <= 0'
             write(6,*) 'area = ', area
             write(6,*) 'i = ', i
             write(6,'(A,A,A,A)') 'This usually means that there ',
     &              'is a problem with your mapping function. ',
     &              'Check to be sure your mapping is valid in ',
     &              'ghost cell regions. '
             write(6,*) 'Area is being to set abs(area)'
             area = abs(area)
             stop
         endif
c
         aux(i,mcapa) = area/dx
         aux(i,2) = xc
         aux(i,3) = quad(0,1)     
         enddo
      return
c
      end
c
c -------------------------------------------------------------
c
      subroutine compute_info1(quad,area,xc)
      implicit double precision (a-h,o-z)
      dimension quad(0:1,1)
c
      dx   = quad(1,1)-quad(0,1)
      xc   = quad(0,1)+0.5d0*dx
      area = dx
      return
c
      end
