c
c -------------------------------------------------------------------
c
      subroutine thomas(A,B,C,D,maxm,mbc,na,nb)
      implicit double precision (a-h,o-z)
      dimension A(1-mbc:maxm+mbc)
      dimension B(1-mbc:maxm+mbc)
      dimension C(1-mbc:maxm+mbc)
      dimension D(1-mbc:maxm+mbc)
c
c     # Thomas algorithm
c     # a direct tridiagonal linear system solver
c     # A: subdiagonal
c     # B: diagonal
c     # C: supdiagonal
c     # D: right-hand side
c
c     # establish upper triangular matrix
      do i=na+1,nb 
         r = A(i)/B(i-1)
         B(i) = B(i)-r*C(i-1)
         D(i) = D(i)-r*D(i-1)
         enddo
c
      D(nb) = D(nb)/B(nb)
c
c     # backward substitution
      do i=nb-1,na,-1
         D(i) = (D(i)-C(i)*D(i+1))/B(i)
         enddo
      return
c
      end
